#ifndef EFL_GENERATED_ECORE_AUDIO_HH
#define EFL_GENERATED_ECORE_AUDIO_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio.eo.h"
}

#include "eo_base.eo.hh"
#include <string>

struct ecore_audio;

namespace eo_cxx {

struct ecore_audio
{
   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const;


   /// @brief Get the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   ::efl::eina::optional< std::string > name_get() const;


   /// @brief Set the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   void name_set(::efl::eina::optional< std::string > name_) const;


   /// @brief Get the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   bool paused_get() const;


   /// @brief Set the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   void paused_set(bool paused_) const;


   /// @brief Get the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   double volume_get() const;


   /// @brief Set the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   void volume_set(double volume_) const;


   /// @brief Get the source of the object
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   ::efl::eina::optional< std::string > source_get() const;


   /// @brief Set the source of the object
   ///
   /// What sources are supported depends on the actual object. For example,
   /// the libsndfile class accepts WAV, OGG, FLAC files as source.
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   bool source_set(::efl::eina::optional< std::string > source_) const;


   /// @brief Get the format of the object
   ///
   /// After setting the source if the format was ECORE_AUDIO_FORMAT_AUTO this
   /// function will now return the actual format.
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   Ecore_Audio_Format format_get() const;


   /// @brief Set the format of the object
   ///
   /// What formats are supported depends on the actual object. Default is
   /// ECORE_AUDIO_FORMAT_AUTO
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   bool format_set(Ecore_Audio_Format format_) const;



   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_CLASS);
   }

   operator ::ecore_audio() const;
   operator ::ecore_audio&();
   operator ::ecore_audio const&() const;

   template <typename D>
   struct address_of
   {
      operator ::ecore_audio*() const { return static_cast<::ecore_audio*>(static_cast<D const*>(this)->p); }
      operator ::ecore_audio const*() const { return static_cast<::ecore_audio const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::ecore_audio const*() const { return static_cast<::ecore_audio const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct ecore_audio
      : ::efl::eo::concrete
      , ::eo_cxx::eo::base
{
   ecore_audio(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : ecore_audio(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio(ecore_audio const& other)
      : ecore_audio(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio() {}

   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const;


   /// @brief Get the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   ::efl::eina::optional< std::string > name_get() const;


   /// @brief Set the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   void name_set(::efl::eina::optional< std::string > name_) const;


   /// @brief Get the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   bool paused_get() const;


   /// @brief Set the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   void paused_set(bool paused_) const;


   /// @brief Get the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   double volume_get() const;


   /// @brief Set the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   void volume_set(double volume_) const;


   /// @brief Get the source of the object
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   ::efl::eina::optional< std::string > source_get() const;


   /// @brief Set the source of the object
   ///
   /// What sources are supported depends on the actual object. For example,
   /// the libsndfile class accepts WAV, OGG, FLAC files as source.
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   bool source_set(::efl::eina::optional< std::string > source_) const;


   /// @brief Get the format of the object
   ///
   /// After setting the source if the format was ECORE_AUDIO_FORMAT_AUTO this
   /// function will now return the actual format.
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   Ecore_Audio_Format format_get() const;


   /// @brief Set the format of the object
   ///
   /// What formats are supported depends on the actual object. Default is
   /// ECORE_AUDIO_FORMAT_AUTO
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   bool format_set(Ecore_Audio_Format format_) const;



   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_CLASS);
   }

   struct address_of
      : ::eo_cxx::ecore_audio::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::ecore_audio* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::ecore_audio::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::ecore_audio const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ECORE_AUDIO_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::ecore_audio) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::ecore_audio>::value, "");

inline void ecore_audio::vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
}


inline ::efl::eina::optional< std::string > ecore_audio::name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
}


inline void ecore_audio::name_set(::efl::eina::optional< std::string > name_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_name_set(::efl::eolian::to_c(name_)));
}


inline bool ecore_audio::paused_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_paused_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void ecore_audio::paused_set(bool paused_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_paused_set(::efl::eolian::to_c(paused_)));
}


inline double ecore_audio::volume_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_volume_get());
   return _tmp_ret;
}


inline void ecore_audio::volume_set(double volume_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_volume_set(volume_));
}


inline ::efl::eina::optional< std::string > ecore_audio::source_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
}


inline bool ecore_audio::source_set(::efl::eina::optional< std::string > source_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(::efl::eolian::to_c(source_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline Ecore_Audio_Format ecore_audio::format_get() const
{
   Ecore_Audio_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
   return _tmp_ret;
}


inline bool ecore_audio::format_set(Ecore_Audio_Format format_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::ecore_audio::vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
}


inline ::efl::eina::optional< std::string > eo_cxx::ecore_audio::name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::ecore_audio::name_set(::efl::eina::optional< std::string > name_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_name_set(::efl::eolian::to_c(name_)));
}


inline bool eo_cxx::ecore_audio::paused_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_paused_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::ecore_audio::paused_set(bool paused_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_paused_set(::efl::eolian::to_c(paused_)));
}


inline double eo_cxx::ecore_audio::volume_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_volume_get());
   return _tmp_ret;
}


inline void eo_cxx::ecore_audio::volume_set(double volume_) const
{
   eo_do(_concrete_eo_ptr(), ::ecore_audio_obj_volume_set(volume_));
}


inline ::efl::eina::optional< std::string > eo_cxx::ecore_audio::source_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
}


inline bool eo_cxx::ecore_audio::source_set(::efl::eina::optional< std::string > source_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(::efl::eolian::to_c(source_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline Ecore_Audio_Format eo_cxx::ecore_audio::format_get() const
{
   Ecore_Audio_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
   return _tmp_ret;
}


inline bool eo_cxx::ecore_audio::format_set(Ecore_Audio_Format format_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline ::eo_cxx::ecore_audio::operator ::ecore_audio() const
{
   return *static_cast<::ecore_audio const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::ecore_audio::operator ::ecore_audio&()
{
   return *static_cast<::ecore_audio*>(static_cast<void*>(this));
}

inline ::eo_cxx::ecore_audio::operator ::ecore_audio const&() const
{
   return *static_cast<::ecore_audio const*>(static_cast<void const*>(this));
}

template <typename T>
void _ecore_audio_vio_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
{
   try
      {
         static_cast<T*>(self->this_)->vio_set(vio_, data_, free_func_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< std::string > _ecore_audio_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eina::optional< std::string > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _ecore_audio_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         static_cast<T*>(self->this_)->name_set(::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _ecore_audio_paused_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->paused_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _ecore_audio_paused_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool paused_)
{
   try
      {
         static_cast<T*>(self->this_)->paused_set(::efl::eolian::to_cxx<bool>(paused_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double _ecore_audio_volume_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->volume_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _ecore_audio_volume_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double volume_)
{
   try
      {
         static_cast<T*>(self->this_)->volume_set(volume_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< std::string > _ecore_audio_source_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eina::optional< std::string > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool _ecore_audio_source_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * source_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_set(::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(source_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Ecore_Audio_Format _ecore_audio_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Ecore_Audio_Format _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool _ecore_audio_format_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Format format_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->format_set(format_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      virtual ::efl::eina::optional< std::string > name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void name_set(::efl::eina::optional< std::string > name_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_name_set(::efl::eolian::to_c(name_)));
      }

      virtual bool paused_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_paused_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void paused_set(bool paused_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_paused_set(::efl::eolian::to_c(paused_)));
      }

      virtual double volume_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_volume_get());
            return _tmp_ret;
      }

      virtual void volume_set(double volume_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_volume_set(volume_));
      }

      virtual ::efl::eina::optional< std::string > source_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_source_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< std::string >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool source_set(::efl::eina::optional< std::string > source_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_source_set(::efl::eolian::to_c(source_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Ecore_Audio_Format format_get()
      {
         Ecore_Audio_Format _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_format_get());
            return _tmp_ret;
      }

      virtual bool format_set(Ecore_Audio_Format format_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_format_set(format_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio >
{
   static const int value = 11 + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::ecore_audio>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_vio_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_vio_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_name_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_name_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_name_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_name_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_ecore_audio_paused_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_paused_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_ecore_audio_paused_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_paused_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_ecore_audio_volume_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_volume_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_ecore_audio_volume_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_volume_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_ecore_audio_source_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_ecore_audio_source_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_ecore_audio_format_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_ecore_audio_format_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[11]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::ecore_audio >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::ecore_audio, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::ecore_audio>)
{
   return (ECORE_AUDIO_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_HH

